config/routes.rb
require "sidekiq/web"
Sidekiq::Web.set :session_secret, Rails.application.credentials[:secret_key_base]

Rails.application.routes.draw do
  mount LetterOpenerWeb::Engine, at: "/letter_opener" if Rails.env.development?

  authenticate :user, lambda { |user| AuthorizedUser.new(user || User.new).can_admin_system? } do
    mount Sidekiq::Web => "/sidekiq"
  end

  devise_for :users, controllers: {
    sessions: "sessions",
    invitations: "invitations",
  }

  resources :jobs, only: [:index]
  resources :job_posting_prospects, except: [:index, :destroy], path: "/jobs/listings"
  scope "/jobs/listings/:job_posting_id" do
    resource :job_posting_user, only: [:new, :create], path: "/user"
    resource :job_posting_purchase, only: [:new, :create, :show], path: "/purchase"
  end
  resources :job_postings, except: [:new, :create], path: "/jobs/directory"

  root to: "pages#index"

  resource :administrator_dashboards, only: [:show], path: "/dashboards/administrator"
  resource :advertiser_dashboards, only: [:show], path: "/dashboards/advertiser"
  resource :publisher_dashboards, only: [:show], path: "/dashboards/publisher"
  resources :campaign_searches, only: [:create, :update, :destroy]
  resources :creative_searches, only: [:create, :update, :destroy]
  resources :job_posting_searches, only: [:create, :update, :destroy], path: "/jobs/searches"
  resources :organization_searches, only: [:create, :update, :destroy]
  resources :property_searches, only: [:create, :update, :destroy]
  resources :user_searches, only: [:create, :update, :destroy]
  resource :creative_options, only: [:show]

  resources :organizations
  scope "/organization/:organization_id/" do
    resources :organization_transactions, path: "/transactions"
    resources :users, path: "/members", as: :organization_users
    resources :comments, only: [:index], as: :organization_comments
    resources :events, only: [:index], as: :organization_events
    resources :versions, only: [:index], as: :organization_versions, path: "/revisions"
  end

  resources :email_templates

  scope "/jobs", manage_scope: true do
    resources :job_postings, only: [:index, :edit, :update, :destroy], path: "/manage", as: :manage_job_postings
  end

  # polymorphic based on: app/models/concerns/imageable.rb
  scope "/imageables/:imageable_gid/" do
    resources :image_searches, only: [:create, :update, :destroy]
    resources :images, except: [:show]
  end

  resources :versions, only: [:show, :update]
  resources :comments, only: [:create, :destroy]

  resources :applicants
  scope "/applicants/:applicant_id" do
    resource :applicant_results, only: [:show], path: "/results"
    resource :applicant_email_template_preview, only: [:show], path: "/:email_template_id/preview", defaults: {format: :json}
    resources :applicant_emails, only: [:new, :create], path: "/emails"
    resources :comments, only: [:index], as: :applicant_comments
    resources :events, only: [:index], as: :applicant_events
  end

  resources :campaigns
  scope "/campaigns/:campaign_id" do
    resource :campaign_targeting, only: [:show], path: "/targeting"
    resource :campaign_budget, only: [:show], path: "/budget"
    resource :campaign_dashboards, only: [:show], path: "/overview"
    resources :campaign_properties, only: [:index], path: "/properties"
    resources :versions, only: [:index], as: :campaign_versions, path: "/revisions"
    resources :comments, only: [:index], as: :campaign_comments
    resources :events, only: [:index], as: :campaign_events
  end

  resources :creatives
  scope "/creatives/:creative_id" do
    resources :events, only: [:index], as: :creative_events
    resource :creative_previews, only: [:show], path: "/preview/:template/:theme"
  end

  # this action should semantically be a `create`,
  # but we are using `show` because it renders the pixel image that creates the impression record
  resources :impressions, only: [:show], path: "/display", constraints: ->(req) { req.format == :gif }
  scope "/impressions/:impression_id" do
    # this action should semantically be a `create`,
    # but we are using `show` because its also a pass through that redirects to the campaign url
    resource :advertisement_clicks, only: [:show], path: "/click"
  end

  # TODO: deprecate legacy support on 2019-04-01
  # Legacy embed script support
  get "/scripts/:legacy_property_id/embed.js", to: "advertisements#show"
  # Legacy impressions api support
  post "/api/v1/impression/:legacy_property_id", to: "advertisements#show", defaults: {format: :json}
  get "/t/s/:legacy_property_id/details", to: "advertisements#show", defaults: {format: :json}

  resources :properties do
    resource :property_screenshots, only: [:update]
  end
  scope "/properties/:property_id" do
    resource :property_instructions, only: [:show], path: "/instructions"
    resource :property_keywords, only: [:show], path: "/keywords"
    resource :property_earnings, only: [:show], path: "/earnings"
    resource :property_dashboards, only: [:show], path: "/overview"
    resources :property_campaigns, only: [:index], path: "/campaigns"
    resources :versions, only: [:index], as: :property_versions, path: "/revisions"
    resource :advertisements, only: [:show], path: "/funder", constraints: ->(req) { [:js, :html, :json].any? req.format }
    resource :advertisement_previews, only: [:show], path: "/preview" if Rails.env.development?
    resources :comments, only: [:index], as: :property_comments
    resources :events, only: [:index], as: :property_events
  end

  resources :templates
  resources :themes
  resources :users
  resource :user_passwords, only: [:edit, :update], path: "/password"

  scope "/users/:user_id" do
    resources :campaigns, only: [:index], as: :user_campaigns
    resources :properties, only: [:index], as: :user_properties
    resources :creatives, only: [:index], as: :user_creatives
    resources :versions, only: [:index], as: :user_versions, path: "/revisions"
    resources :comments, only: [:index], as: :user_comments
    resources :events, only: [:index], as: :user_events
    resource :identicon, only: [:show], format: :png, as: :user_identicon, path: "/identicon.png"
    resource :impersonations, only: [:update], as: :user_impersonation, path: "/impersonate"
  end
  get "/stop_user_impersonation", to: "impersonations#destroy", as: :stop_user_impersonation

  resource :newsletter_subscription, only: [:create]
  resources :advertisers, only: [:index, :create]
  resources :publishers, only: [:index, :create]

  # IMPORTANT: leave as last route so it doesn't override others
  resources :pages, only: [:show], path: "/"
end

app/controllers/job_posting_users_controller.rb
class JobPostingUsersController < ApplicationController
  before_action :set_job_posting

  def new
    return redirect_to(new_job_posting_purchase_path(@job_posting)) if User.find_by(email: @job_posting.company_email)
    @user = User.new(
      email: @job_posting.company_email,
      company_name: @job_posting.company_name,
    )
  end

  def create
    return redirect_to(new_job_posting_purchase_path(@job_posting)) if User.find_by(email: @job_posting.company_email)
    @user = User.new(user_params)
    if @user.save
      sign_in @user
      @job_posting.update user: @user
      session[:job_posting_prospect_id] = @job_posting.id
      redirect_to new_job_posting_purchase_path(@job_posting), notice: "Your account was successfully created."
    else
      render :new
    end
  end

  private

  def set_job_posting
    @job_posting = JobPosting.find(params[:job_posting_id])
  end

  def user_params
    params.require(:user).permit(:first_name, :last_name, :company_name, :email).
      tap do |whitelisted|
        whitelisted[:password] = SecureRandom.hex[0, 8].upcase
        whitelisted[:password_confirmation] = whitelisted[:password]
        whitelisted[:confirmed_at] = Time.current
        whitelisted[:roles] = [ENUMS::USER_ROLES::EMPLOYER]
      end
  end
end

app/helpers/job_posting_users_helper.rb
module JobPostingUsersHelper
end

app/views/job_posting_users/_form.html.erb
<%= simple_form_for @user, url: job_posting_user_path, wrapper: :front_form do |f| %>
  <%= render "/@shared/forms/error_messages", object: @user %>

  <h2 class="h5 mt-3">Account Info</h2>

  <p>
    It looks like this might be your first job posting with CodeFund. In order to post a job,
    we need to create a user account. With this account, you will have access to:
  </p>

  <ul class="text-muted pb-3">
    <li>Anaytics (impressions, clicks)</li>
    <li>Renewals and cancellations</li>
    <li>CodeFund Ads placement (coming soon)</li>
  </ul>

  <div class="row">
    <%= tag.div f.input(:first_name, required: true, placeholder: "First Name"), class: "col-md-6 mb-4" %>
    <%= tag.div f.input(:last_name, required: true, placeholder: "Last Name"), class: "col-md-6 mb-4" %>
    <%= tag.div f.input(:company_name, required: true, placeholder: "Company Name"), class: "col-12 mb-4" %>
    <%= tag.div f.input(:email, required: true, as: :email, placeholder: "Email Address"), class: "col-12 mb-4" %>
  </div>

  <div class="d-flex space-top-1">
    <%= link_to "Make Changes", edit_job_posting_prospect_path(@job_posting),
          class: "btn btn-block btn-sm btn-soft-secondary transition-3d-hover mr-1" %>
    <%= f.submit "Next", class: "btn btn-block btn-sm btn-primary transition-3d-hover ml-1 mt-0" %>
  </div>
<% end %>

app/views/job_posting_users/new.html.erb
<main id="content" role="main" class="bg-light">
  <div class="container space-top-3 space-bottom-2">
    <div class="w-lg-80 mx-lg-auto">
      <div class="card shadow-sm p-7 job-listing">
        <%= render partial: "/job_posting_prospects/nav" %>

        <% if @user.persisted? %>
          <h2 class="h5 mt-3">Account Info</h2>

          <p>
            It looks like you already have a CodeFund account.
            Please <%= link_to "login", new_user_session_path %> or
            <%= link_to "change the company email", edit_job_posting_prospect_path(@job_posting) %>
            on the listing before posting.
          </p>
        <% else %>
          <%= render partial: "/job_posting_users/form" %>
        <% end %>
      </div>
    </div>
  </div>
</main>